
#ifndef _ETHERNET_H_
#define _ETHERNET_H_

#include "commdef.h"
#include "interface.h"

#ifdef _WIN32
#include "Winsock2.h"
#endif


#ifdef _WIN32
class ARCLIB_API EthernetInterface : public ArcInterface
#else
class EthernetInterface : public ArcInterface
#endif
{
public:		
	EthernetInterface();	
	~EthernetInterface();
	bool init(const char *szIPAddr, short nPort = 7890);
	int send(const char *outBuf, int outLen);	
	int recv(char *inBuf, int inLen);		
	int syncSend(const char *outBuf, int outLen, char *inBuf, int inLen );
	void setTimeOut(int nSec);

// helper functions
public:
	SOCKET getSocket();

private:
	int	 WaitForReply(SOCKET s, long time_sec, long time_usec);
	SOCKET m_socket;
#ifdef _WIN32
	CRITICAL_SECTION m_cs;
#elif __linux__
	
#endif
	struct	sockaddr_in agentaddr;
	int m_nTimeout;
};

#endif

